<template>
  <b-carousel
    id="carousel-1"
    v-model="slide"
    :interval="4000"
    controls
    indicators
    background="#ababab"
    img-width="1024"
    img-height="480"
    style="text-shadow: 1px 1px 2px #333;"
    @sliding-start="onSlideStart"
    @sliding-end="onSlideEnd"
  >
    <div v-for="slideData in slideDatas" :key="slideData.id">
      <b-carousel-slide
        v-bind:caption="slideData.title"
        v-bind:text="slideData.overview|maxCharSubTitle"
        v-bind:img-src="'https://image.tmdb.org/t/p/w1280/'+slideData.backdrop_path"
      ></b-carousel-slide>
    </div>
  </b-carousel>
</template>

<script>
export default {
  props: ['slideDatas'],
  data () {
    return {
      slide: 0,
      sliding: null,
      data: this.slideDatas
    }
  },
  filters: {
    maxCharSubTitle (value) {
      const maxCharSubTitle = 100
      const modSubTitle =
        value.length > maxCharSubTitle
          ? `${value.substr(0, maxCharSubTitle)}...`
          : value
      return modSubTitle
    }
  },
  methods: {
    onSlideStart (slide) {
      this.sliding = true
    },
    onSlideEnd (slide) {
      this.sliding = false
    }
  }
}
</script>
<style>
.carousel-inner {
  height: 40rem;
}

.carousel-caption {
  top: 31rem;
}
</style>
